
; BE AWARE: identation matters for RV ARM assembler !!
; BE AWARE: ALL ASM FUNCTION MUST HAVE 8 BYTE STACK ALIGMENT USAGE IF THEY CALL C FUNCTIONS

;------------------------------------------------------------------------------

	GET	const.s

;------------------------------------------------------------------------------

CMovieCore__m_PanelResolution	EQU	0x025FC704
g_ToolResMgr			EQU	0x02601698

;------------------------------------------------------------------------------

CResourceManager__GetWString	EQU	0x00A3CABC, ARM
CMMPlayerWrapper_GetMmpProfile	EQU	0x00A5072C, ARM
ROSE_PRINT			EQU	0x0086F980, ARM

;------------------------------------------------------------------------------

	EXPORT		CMovieCore__m_PanelResolution
	EXPORT		g_ToolResMgr

	EXPORT		CResourceManager__GetWString
	EXPORT		CMMPlayerWrapper_GetMmpProfile
	EXPORT		ROSE_PRINT

;------------------------------------------------------------------------------

	IMPORT		pwGetToolItemTextPtr
	IMPORT		bDisplaySizeItem_PressLeftRightKey
	IMPORT		dwCustomCalcDisplaySize

;------------------------------------------------------------------------------

	PRESERVE8	; if you want to call C functions you have to use 8 byte align stack

;------------------------------------------------------------------------------
; CToolMmbDisplaySizeItem::GetToolItemTextData

	AREA	PATCH_SEG_000, CODE, READONLY
	ARM

	MOV	R0, R3
	BL	pwGetToolItemTextPtr
	B	0x0135A7AC		; return

;------------------------------------------------------------------------------
; CToolMmbDisplaySizeItem::PressLeftRightKey

PS001_bDisplaySize	EQU	0x17

	AREA	PATCH_SEG_001, CODE, READONLY
	ARM

	STMFD	SP!, {R4, R5, LR}
	SUB	SP, SP, #0x18
	ADD	R4, SP, #0x18
	MOV	R5, R1		; save input keycode
	MOV	R3, #0
	STRB	R3, [R4,#-1]!
	MOV	R0, #6
	MOV	R1, R4
	BL	CMMPlayerWrapper_GetMmpProfile
	CMP	R0, #0
	BEQ	0x0135AAC4	; return FALSE

	LDRB	R0, [SP, #PS001_bDisplaySize]
	MOV	R1, R5
	BL	bDisplaySizeItem_PressLeftRightKey
	STRB	R0, [SP, #PS001_bDisplaySize]

	B	0x0135AAB0	; call  CMMPlayerWrapper::SetMmpProfile

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	AREA	PATCH_SEG_001_2, CODE, READONLY
	ARM

	ADD	SP, SP, #0x18
	LDMFD	SP!, {R4, R5, PC}

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	AREA	PATCH_SEG_DS, CODE, READONLY
	ARM

	MOV	R1, R10
	MOV	R2, R8
	BL	dwCustomCalcDisplaySize		; In: (u8 bDisplaySize, u32 dwFrameWidth, u32 dwFrameHeight) --- Out: R0_LO = width ; R0_HI = height

	; save frame size
	MOV	R1, R8
	MOV	R2, R10

	; width		
	MOV	R10, R0, LSL#16
	MOV	R10, R10, LSR#16
	; height
	MOV	R8, R0, LSR#16

	B	0x00F969C8			; handle as original --- set x, y, w, h

	; restore decoded frame size
	MOV	R8, R1
	MOV	R10, R2

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	AREA	PATCH_SEG_DS_2, CODE, READONLY
	ARM

	B	0x00F96830			; jump back - restore decoded frame size

;------------------------------------------------------------------------------
; CToolMmbAudioLanguageSetItem::AddToolItemFlag

	AREA	PATCH_SEG_002, CODE, READONLY
	ARM

;;;	MOV	R0, #TOOL_ITEM_FLAG_DISPLAY_SIZE	; "display size" always shown --- so this way "Audio Language Set" will also always shown

;------------------------------------------------------------------------------
; ROSE_PRINT

	AREA	PATCH_SEG_003, CODE, READONLY
	ARM

;;;	NOP

;------------------------------------------------------------------------------
; TDcDebug::GetErrorPrint

	AREA	PATCH_SEG_004, CODE, READONLY
	ARM

;;;	NOP
;;;	MOV	R0, #1
;;;	BX	LR

;------------------------------------------------------------------------------
; CDivxDRMSystem::CheckAVIforDivX

	AREA	PATCH_SEG_005, CODE, READONLY
	ARM

;;;	B	0x00F9EB8C

;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------


	AREA	NEW_CODE_SEG, CODE
	ARM

;CustomCalcDisplaySize	PROC
;
;	ENDP

;------------------------------------------------------------------------------

	END
